<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.registry.ui.common.utils.RegistryUtil" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>

<jsp:include page="../dialog/dialog_header.jsp"/>
<jsp:include page="../dialog/display_messages.jsp"/>

<!-- YUI inculudes for rich text editor -->
<link rel="stylesheet" type="text/css"
      href="../yui/build/editor/assets/skins/sam/simpleeditor.css"/>
<script type="text/javascript" src="../yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="../yui/build/element/element-beta-min.js"></script>
<script type="text/javascript" src="../yui/build/container/container_core-min.js"></script>
<script type="text/javascript" src="../yui/build/editor/simpleeditor-min.js"></script>

<!-- other includes -->
<script type="text/javascript" src="../registry_common/js/registry_validation.js"></script>
<script type="text/javascript" src="../registry_common/js/registry_common.js"></script>
<script type="text/javascript" src="../ajax/js/prototype.js"></script>
<script type="text/javascript" src="js/resource_util.js"></script>
<link rel="stylesheet" type="text/css" href="css/registry.css"/>

<script type="text/javascript">
  <!--
    loadMediaTypes();
  // -->
  </script>

<fmt:bundle basename="org.wso2.carbon.registry.ui.resource.i18n.Resources">
<carbon:breadcrumb label="resources"
                       resourceBundle="org.wso2.carbon.registry.ui.resource.i18n.Resources"
                       topPage="true" request="<%=request%>"/>

    <%
        boolean infoFound = CarbonUIUtil.isContextRegistered(config, "/info/");

        boolean propertiesFound = CarbonUIUtil.isContextRegistered(config, "/properties/");

        boolean relationsFound = CarbonUIUtil.isContextRegistered(config, "/relations/");

        boolean searchFound = CarbonUIUtil.isContextRegistered(config, "/search/");

        boolean lifecyclesFound = CarbonUIUtil.isContextRegistered(config, "/lifecycles/");
    %>
    <style type="text/css">
        .yui-skin-sam h3 {
            font-size: 10px !important;
        }

        .yui-toolbar-container .yui-toolbar-titlebar h2 a {
            font-size: 11px !important;
        }
    </style>
    <div id="middle">

        <h2><fmt:message key="registry.resources.menu"/></h2>

        <div id="workArea">
            <div class="resource-path">
                <jsp:include page="metadata_resourcepath.jsp"/>
            </div>
            <table width="100%">

                <tr>

                    <td id="resourceMain">
                        <div id="metadataDiv">
                            <jsp:include page="metadata_ajaxprocessor.jsp"/>
                        </div>

                        <% if (propertiesFound) {
                            String propertiesPath = "../properties/properties-main-ajaxprocessor.jsp?path=" + RegistryUtil.getPath(request);
                        %>
                        <div id="propertiesDiv">
                            <jsp:include page="<%=propertiesPath%>"/>
                        </div>
                        <% } %>

                        <div id="contentDiv">
                            <jsp:include page="content_ajaxprocessor.jsp"/>
                        </div>                        
                        <div id="permissionsDiv" style="*margin-top:40px;">
                            <jsp:include page="permissions_ajaxprocessor.jsp"/>
                        </div>
                    </td>
                    <% if (infoFound || relationsFound) { 
                       String contraction = "min";
                       if(session.getAttribute( "contraction" )!=null){
                       	contraction = (String)session.getAttribute( "contraction" );
                       }
                    %>
                    <td class="contraction-spacer"></td>
                    <td id="pointLeft" <% if (contraction.equals("min")){ %>style="display:none;"<% } %>><a class="pointLeft" title="<fmt:message key="resource.show.left"/>"
                                                                onclick="showHideResources()"></a>
                    </td>
                    
                    
                    <td id="pointRight" <% if (contraction.equals("exp")){ %>style="display:none;"<% } %>><a class="pointRight" onclick="showHideResources()" title="<fmt:message key="resource.hide.left"/>"></a>
                    </td>
                    <td class="resource-right" id="resourceInfo" <% if (contraction.equals("exp")){ %>style="display:none;"<% } %>>

                        <% if (searchFound) {
                            String searchPath = "../search/simpleSearch.jsp";
                        %>
                        <jsp:include page="<%=searchPath%>"/>
                        <% } %>

                        <% if (infoFound) {
                            String infoPath = "../info/info_ajaxprocessor.jsp?path=" + RegistryUtil.getPath(request);
                        %>
                        <div id="infoDiv">
                            <jsp:include page="<%=infoPath%>"/>
                        </div>
                        <% } %>

                        <% if (relationsFound) {
                            String relationsPath = "../relations/relations.jsp?path=" + RegistryUtil.getPath(request);
                        %>
                        <jsp:include page="<%=relationsPath%>"/>
                        <% } %>

                        <% if (lifecyclesFound) {
                            String lifecyclesPath = "../lifecycles/lifecycles_ajaxprocessor.jsp?path=" + RegistryUtil.getPath(request);
                        %>
                        <div id="lifecyclesDiv">
                            <jsp:include page="<%=lifecyclesPath%>"/>
                        </div>
                        <% } %>
                    </td>

                    <% } %>
                </tr>

            </table>

        </div>
    </div>

    <div id="resourceTree" style="display:none" class="resourceTreePage">
        <div class="ajax-loading-message">
            <img src="/wso2registry/admin/images/ajax-loader.gif" align="top"/>
            <span><fmt:message key="resource.tree.loading.please.wait"/> ..</span>
        </div>
    </div>
    <div id="popup-main" style="display:none" class="popup-main">
    </div>
</fmt:bundle>
