<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.user.ui.client.UserMgtClient" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.CarbonError" %>
<%@page import="java.util.List"%>
<%@page import="java.util.Arrays"%>
<%@page import="org.wso2.carbon.ui.CarbonUIMessage"%>
<jsp:useBean id="roleBean" type="org.wso2.carbon.user.ui.client.RoleBean" scope="session"/>
<jsp:setProperty name="roleBean" property="*" />

<script type="text/javascript" src="../userstore/extensions/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>
<jsp:include page="../dialog/dialog_header.jsp"/>
<jsp:include page="../dialog/display_messages.jsp"/>
<fmt:bundle basename="org.wso2.carbon.userstore.ui.i18n.Resources">
    <carbon:breadcrumb label="add.users"
                       resourceBundle="org.wso2.carbon.userstore.ui.i18n.Resources"
                       topPage="false" request="<%=request%>"/>

    <script type="text/javascript">
        function doValidation() {
            var reason = "";
            return true;
        }

        function doCancel() {
            location.href = 'role-mgt.jsp?ordinal=1';
        }
        
        function doNext() {
            document.addRoleForm.action="add-step3.jsp";
            if(doValidation() == true){
                document.addRoleForm.submit();
            }
        }
        
        function doFinish() {
            document.addRoleForm.action="add-finish.jsp";
            if(doValidation() == true){
                document.addRoleForm.submit();
            }
        }

        function goBack() {
            history.go(-1);
        }
    </script>

    <%
       String[] datas = null;
       String[] selected = null;
    
	   String filter = (String)request.getParameter("org.wso2.usermgt.role.add.filter");
	   if(filter == null){
	      filter = "*";
	   }else{
	      filter = filter.trim();
	   }
       
        String userType = (String)session.getAttribute("org.wso2.carbon.user.userType");
        try {
            String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
            ConfigurationContext configContext =
                    (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
            UserMgtClient client = new UserMgtClient(cookie, backendServerURL, configContext);
            if(filter.length() > 0){
        	    if ("external".equals(userType)) {
        		    datas = client.listExternalUsers(filter);
        		}else{
        		    System.out.println();
        		    datas = client.listInternalUsers(filter);
        		}
            }
            selected = roleBean.getSelectedUsers();
        } catch (Exception e) {
            CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
            session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
            <jsp:include page="../admin/error.jsp"/>
<%
            return;
        }
    %>

    <div id="middle">
        <h2><fmt:message key="add.user.role"/></h2>

        <div id="workArea">
            <h3><fmt:message key="step.2.role"/></h3>
            <form name="filterForm" method="post" action="add-step2.jsp">
                <table class="normal">
                    <tr>
                        <td><fmt:message key="list.users"/></td>
                        <td>
                           <input type="text" name="org.wso2.usermgt.role.add.filter" value="<%=filter%>"/>
                        </td>
                        <td>
                        <input class="button" type="submit" value="<fmt:message key="user.search"/>" />
                        </td>
                    </tr>
                </table>
            </form>
            <form method="get" name="addRoleForm">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="add.users"/></th>
                    </tr>
                    </thead>
                    <tr>
                        <td class="formRaw">
                            <table class="normal">
                                <tr>
                                    <td>
                                      <input type="checkbox" name="selectAll"
                                               onclick="doSelectUnselectAll('selectAll', 'selectedUsers');"/><fmt:message key="select.all"/> 
                                        <table>
                                            <tbody>
                                            <%
                                                if (datas != null) {
                                                    int count = 0;
                                                    List<String> list = Arrays.asList(selected); 
                                                    for (String data : datas) {
                                                        if (data != null) {
                                                            
                                                            if("anonymous".equals(data)){
                                                        	   continue;
                                                            }
                                                            
                                                            if("system".equals(data)){
                                                                continue;
                                                            }
                                                            
                                                            if("everyone".equals(data)){
                                                                continue;
                                                            }
                                                            
                                                           if(count == UserMgtClient.MAX_USER_COUNT){
                                                                break;
                                                           }
                                                           count ++;
                                                            
                                                            String docheck =  "";
                                                            if (list.contains(data)) {
                                                                docheck = "checked=\"checked\"";
                                                            }
                                            %>
                                            <tr>
                                                <td><input type="checkbox"
                                                           name="selectedUsers"
                                                           value="<%=data%>"  <%=docheck%>/><%=data%>
                                                </td>
                                            </tr>
                                            <%
                                                        }
                                                    }
                                                }
                                            %>
                                            </tbody>
                                        </table>
                                    </td>
                                </tr>
                            </table>
                            <!-- normal table -->
                        </td>
                    </tr>
                    <%
                        if(datas != null){
                            int length = datas.length; 
                            if(length > UserMgtClient.MAX_USER_COUNT){
                            %>
                            <tr><td><strong><fmt:message key="more.users"/></strong></td></tr>
                            <%
                            }
                        }
                    %>
                    <tr>
                        <td class="buttonRow">
                            <input type="button" class="button" value="< <fmt:message key="back"/>" onclick="goBack();"/>
                            <input type="button" class="button" value="<fmt:message key="next"/> >" onclick="doNext();"/>
                            <input type="button" class="button" value="<fmt:message key="finish"/>" onclick="doFinish();">
                            <input type="button" class="button" value="<fmt:message key="cancel"/>" onclick="doCancel();"/>
                        </td>
                    </tr>
                </table>
            </form>
        </div>
    </div>
</fmt:bundle>