<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@page import="org.wso2.carbon.security.ui.client.SecurityAdminClient" %>
<%@page
        import="org.wso2.carbon.security.ui.config.xsd.SecurityScenarioData" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="java.util.ResourceBundle" %>
<%@ page import="java.text.MessageFormat" %>
<script type="text/javascript" src="extensions/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>
<jsp:include page="../dialog/display_messages.jsp"/>

<fmt:bundle basename="org.wso2.carbon.security.ui.i18n.Resources">
<carbon:breadcrumb label="security.for.the.service"
                   resourceBundle="org.wso2.carbon.security.ui.i18n.Resources"
                   topPage="false" request="<%=request%>"/>
<%
    String BUNDLE = "org.wso2.carbon.security.ui.i18n.Resources";
    ResourceBundle resourceBundle = ResourceBundle.getBundle(BUNDLE, request.getLocale());
    String[] options = new String[]{"Yes", "No"};
    String[] optionsValues = new String[]{resourceBundle.getString("yes"), resourceBundle.getString("no")};
%>

<script type="text/javascript">


    function doValidation() {
        var isChecked = false;
        isChecked = isAtleastOneChecked("scenarioId");
        if (isChecked != true) {
            CARBON.showWarningDialog('<fmt:message key="please.select.at.leaset.one.security.scenario"/>');
        }
        return isChecked;
    }


    function showOptions() {
        var temp = document.getElementById("securityConfiguration");
        if (document.getElementById("securityConfigAction").value == "Yes") {
            temp.style.display = "inline";
        } else if (document.getElementById("securityConfigAction").value == "No") {
            CARBON.showConfirmationDialog("<fmt:message key="disable.security.confirm"/>",
                    function() {
                        document.deleteSecurity.submit();
                    },
                    function() {
                        document.getElementById("securityConfigAction").value = "Yes";
                        temp.style.display = "inline";
                    });
        }
    }


</script>
<%!
    String info = null;
    SecurityScenarioData[] basics = null;
    SecurityScenarioData[] advanced = null;
%>
<%!
    String showOption = null;
    String displalyStyle = null;
    int[] optionsOrder = null;

%>
<%!SecurityScenarioData currentScenrio = null;%>
<%
    String serviceName = null;
    serviceName = request.getParameter("serviceName");
    if (serviceName != null) {
        serviceName = serviceName.trim();
        if (serviceName.length() > 0) {
            session.setAttribute("serviceName", serviceName);
        }
    } else {
        serviceName = (String) session.getAttribute("serviceName");
    }

    if (serviceName == null) {
%> <strong><fmt:message
        key="cannot.proceed.please.select.a.service.to.enable.security"/>!</strong> <%
} else {
    //get current scenario
    try {
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        SecurityAdminClient client = new SecurityAdminClient(cookie, backendServerURL, configContext);
        currentScenrio = client.getCurrentScenario(serviceName);

        if (currentScenrio == null) {
            info = MessageFormat.format(resourceBundle.getString("service.not.secured"),
                    new Object[]{serviceName});
            optionsOrder = new int[]{1, 0};
            displalyStyle = "display: none;";
        } else {
            info = MessageFormat.format(resourceBundle.getString("service.secured.using"),
                    new Object[]{serviceName, currentScenrio.getSummary()});
            optionsOrder = new int[]{0, 1};
            displalyStyle = "display: inline;";
        }

        basics = client.getBasicScenarios();
        advanced = client.getAdvancedScenarios();
    } catch (Exception e) {
%>
<strong>An error occured! Message is <%=e.getMessage()%>
</strong>
<%
        return;
    }
%>
<div id="middle">
    <h2><fmt:message key="security.for.the.service"/></h2>

    <div id="workArea">
        <p><%=info%></p>

        <p>&nbsp;</p>

        <table>
            <tr>
                <td><fmt:message key="enable.security"/>?</td>
                <td>
                    <select onchange="showOptions();" id="securityConfigAction" name="enable">
                        <%
                            for (int optionOder : optionsOrder) {
                        %>
                        <option value="<%=options[optionOder]%>"><%=optionsValues[optionOder]%>
                        </option>
                        <%
                            }
                        %>
                    </select>
                </td>
            </tr>
        </table>
        <p>&nbsp;</p>

        <div id="securityConfiguration" style="<%=displalyStyle%>">
            <form id="secConfigForm" name="securityForm" method="post" action="ut-ks-advance.jsp"
                  onsubmit="return doValidation();">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th colspan="2"><fmt:message key="security.scenario"/></th>
                        <th><fmt:message key="description"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <%
                        for (int i = 0; i < basics.length; i++) {
                            SecurityScenarioData temp = basics[i];
                            String secid = temp.getScenarioId();
                    %>
                    <tr>
                        <td>
                            <%
                                if (currentScenrio != null && currentScenrio.getScenarioId().equals(secid)) {
                            %><input type="radio" name="scenarioId" value="<%=secid%>"
                                     checked="checked"/><%
                        } else {
                        %><input type="radio" name="scenarioId" value="<%=secid%>"/><%
                            }
                        %>
                        </td>
                        <td>
                            <%
                                if (secid.equals("scenario1")) {%>UsernameToken<%
                        } else if (secid.equals("scenario2")) {%>Non-repudiation<%
                        } else if (secid.equals("scenario4")) {%>Integrity<%
                        } else if (secid.equals("scenario5")) {%>Confidentiality<%
                            }
                        %>
                        </td>
                        <td><%=temp.getDescription()%>
                        </td>
                    </tr>
                    <%
                        }
                    %>
                    <tr>
                        <td colspan="3" class="sub-header"><fmt:message
                                key="advanced.scenarios"/></td>
                    </tr>
                    <%
                        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
                        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
                        ConfigurationContext configContext =
                                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
                        SecurityAdminClient client = new SecurityAdminClient(cookie, backendServerURL, configContext);
                        currentScenrio = client.getCurrentScenario(serviceName);

                        SecurityScenarioData[] all = client.getAdvancedScenarios();
                        for (int i = 0; i < all.length; i++) {
                            SecurityScenarioData scene = all[i];
                            String scenarioId = scene.getScenarioId();
                            String category = new String(scene.getCategory());
                    %>
                    <tr>
                        <td>
                            <%
                                if (currentScenrio != null && currentScenrio.getScenarioId().equals(scenarioId)) {
                            %><input type="radio" name="scenarioId" value="<%=scenarioId%>"
                                     checked="checked"/><%
                        } else {
                        %><input type="radio" name="scenarioId" value="<%=scenarioId%>"/><%
                            }
                        %>
                        </td>
                        <td><%=scene.getSummary()%>
                        </td>
                        <td><%=scene.getDescription()%>
                        </td>
                    </tr>
                    <%
                        }
                    %>
                    <tr>
                        <td class="buttonRow" colspan="3">
                            <input class="button" type="submit"
                                   value="<fmt:message key="next"/> >"/>
                        </td>
                    </tr>
                    </tbody>
                </table>

            </form>
        </div>
        <%
            }
        %>
        <div id="divDeleteSecurity" style="display: none">
            <form name="deleteSecurity" action="remove-security.jsp">
                <input type="submit" value="<fmt:message key="delete"/>"/>
            </form>
        </div>

    </div>
</div>
</fmt:bundle>