<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@page import="org.wso2.carbon.sts.ui.STSUtil"%>
<%@page import="org.wso2.carbon.sts.ui.service.util.xsd.TrustedServiceData"%>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<jsp:include page="../admin/layout/ajaxheader.jsp"/>

<fmt:bundle basename="org.wso2.carbon.sts.ui.i18n.Resources">
<carbon:breadcrumb 
		label="sts.configuration"
		resourceBundle="org.wso2.carbon.sts.ui.i18n.Resources"
		topPage="true" 
		request="<%=request%>" />
		
<script type="text/javascript" src="../carbon/admin/js/breadcrumbs.js"></script>
<script type="text/javascript" src="../carbon/admin/js/cookies.js"></script>
<script type="text/javascript" src="../carbon/admin/js/main.js"></script>


<script type="text/javascript">

    function doValidation() {
      var reason = "";
      reason = validateEmpty("endpointaddrs");
      if (reason != "") {
        wso2.wsf.Util.alertWarning('Enter a valid : End-point Address');
        return false;
      }       
      return true;
    }       
   
</script>

<%
    TrustedServiceData[] services = null;
    String[] aliases = null;
    STSUtil  sts = null;
    String address = null;
    String keyAlias = null;   
    String cookie = null;
      
    try {    	
    	cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        sts = new STSUtil(config, session,cookie);
        address = (String)request.getParameter("endpointaddrs");
        keyAlias = (String)request.getParameter("alias");
        try {           
           sts.addTrustedService(address,keyAlias);
        } catch (Exception e) {         
        }
        aliases  = sts.getAliasFromPrimaryKeystore();
        services = sts.getTrustedServices();        
    } catch (Exception e) {
%>
		<script>
			<jsp:forward page="../admin/error.jsp?<%=e.getMessage()%>"/>
		</script>
<%  
      return;
    }
%>

<div id="middle">
<h2><fmt:message key="sts.configuration"/></h2>

<div id="workArea">
	<form>
			<table class="styledLeft" width="100%" id="trustedServices">
					<thead>
						<tr>
							<th><fmt:message key="sts.service.endpoint"/></th>
							<th><fmt:message key="sts.certificate.alias"/></th>
						</tr>
					</thead>
					<tbody>
						<%
						if (services != null && services.length>0) {
          					for (TrustedServiceData service : services) {            					 
         				%>
							  <tr>
								<td><%=service.getServiceAddress()%></td>
								<td>&nbsp;&nbsp;<%=service.getCertAlias()%></td>
							  </tr>
						<%
             				 }
          				} else {
        				%>
        				      <tr>
								<td colspan="2"><h4><fmt:message key="sts.trusted.services.not.found"/></h4></</td>								
							  </tr>
					    <% } %>
					</tbody>
			</table>
			<script type="text/javascript">
    			alternateTableRows('trustedServices', 'tableEvenRow', 'tableOddRow');
			</script>		
	</form>

    <form method="get" action="index.jsp" name="trustedservice" onsubmit="return doValidation();">
       		    <table class="styledLeft" width="100%">
            		    <thead>
						   <tr>
							<th colspan="2"><fmt:message key="sts.trusted.services.new"/></th>						
						  </tr>
					    </thead>
                		<tr>
                    		<td><fmt:message key="sts.endpoint.address"/><font color="red">*</font></td>
                    		<td><input type="text" id="endpointaddrs" name="endpointaddrs" style="width: 600px"/></td>
                		</tr>
                       <tr>
                            <td><fmt:message key="sts.certificate.alias"/></td>
                            <td>
                        		<select id="alias" name="alias">
                        	<%
								if (aliases != null) { 
          								for (String alias : aliases) {
            								if (alias != null) { 
         					%>							
												<option value="<%=alias%>"><%=alias%></option>							
							<%
             								}
          								}
								  }
        					%>
                        		</select>
                    		</td>
                		</tr>
                        <tr>
                    		<td>&nbsp;</td>
                    		<td>
                        		<input type="submit" value="<fmt:message key="sts.apply.caption"/>"/>&nbsp;&nbsp;                        
                    		</td>
                		</tr>
         		</table>
     </form>
 </div>

</div>
</fmt:bundle>