package org.wso2.wsas.sample.eventing;

import java.util.Random;

import org.apache.axiom.om.OMAbstractFactory;
import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.apache.axiom.om.OMNamespace;
import org.apache.axis2.AxisFault;
import org.apache.axis2.client.Options;
import org.apache.axis2.context.MessageContext;
import org.apache.axis2.context.ServiceContext;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.savan.publication.client.PublicationClient;
import org.apache.savan.storage.SubscriberStore;
import org.apache.savan.util.CommonUtil;

/**
 * The service implementation class
 */
public class StockQuoteService {

	private static final Log log = LogFactory.getLog(StockQuoteService.class);
	final static String STOCK = "Stock";
	final static String NAMESPACE = "eventing.sample.wsas.wso2.org";
	OMElement data = null;
	Random r = new Random();
	boolean goahead = true;

	/**
	 * 
	 * @throws AxisFault
	 */
	public void publish() throws AxisFault {
		SubscriberStore store = null;
		PublicationClient publicationClient = null;
		ServiceContext serviceContext = null;
		serviceContext = MessageContext.getCurrentMessageContext().getServiceContext();
		Options options = null;
		goahead = true;

		try {
			while (true && goahead) {
				Thread.sleep(5000);
				store = CommonUtil.getSubscriberStore(serviceContext.getAxisService());
				if (store != null) {
					log.info("EVENT_SOURCE:::Publishing next publication...");
					data = getNextPublicationData();
					publicationClient = new PublicationClient(serviceContext
							.getConfigurationContext());
					options = new Options();
					options.setAction("urn:publish");
					try {
						publicationClient.sendPublication(data, serviceContext.getAxisService(),
								null, options);
					} catch (Exception e) {
						// proceed with sending publications.
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void stopPublishing() throws AxisFault {
		goahead = false;
	}

	/**
	 * 
	 * @return
	 */
	private OMElement getNextPublicationData() {
		OMFactory factory = null;
		OMNamespace namespace = null;
		OMElement stockElement = null;
		OMElement data = null;

		factory = OMAbstractFactory.getOMFactory();
		namespace = factory.createOMNamespace(NAMESPACE, "ns1");
		stockElement = factory.createOMElement(STOCK, namespace);

		int value = r.nextInt();
		stockElement.setText(Integer.toString(value));

		data = factory.createOMElement("publish", namespace);
		data.addChild(stockElement);

		return data;
	}
}
